<?php
require_once __DIR__ . "/conn.php";
require_once __DIR__ . "/models/Goods.php";
require __DIR__ . '/vendor/autoload.php';

use Models\Apply;
use Models\CompanyPics;

$json = file_get_contents('php://input');
$json = json_decode($json, true);
if ($json == null) $json = [];
$concat = array_merge($json, $_GET);
$concat = array_merge($concat, $_FILES);
$concat = array_merge($concat, $_POST);
$data = json_decode(json_encode($concat));
//dd($data);
try
{
    $headers = getallheaders();
    //dump($headers);
    $key = str_replace('Bearer ', '', $headers['Authorization']);
    //dump($key);
    $user = loginUser($key);
    if ($user == null) throw new Exception('尚未登入');
    if ($user->type != '求職者') throw new Exception('無權限[1]');
    //dump($user);
    if(\Models\Job::find($data->job_id) == null) throw new Exception('查無此職缺');
    $resume = \Models\Resume::find($data->resume_id);
    if ($resume == null) throw new Exception('查無此履歷');
    if ($resume->user_id != $user->id) throw new Exception('無權限[2]');

    $model = new Apply();
    $model->id = uniqid();
    $model->user_id = $user->id;

    $keys = [
        'job_id', 'resume_id', 'content'
    ];
    foreach ($keys as $k)
    {
        if (property_exists($data, $k)) $model->{$k} = $data->{$k};
    }
    $model->save();

    header("Content-Type: application/json");
    echo json_encode(['issue' => 1, 'data' => $model, 'msg' => '']);
}
catch (Exception $e)
{
    echo json_encode(['issue' => 0, 'msg' => $e->getMessage()], JSON_UNESCAPED_UNICODE);
}


?>
