<?php
require_once __DIR__ . "/conn.php";
require_once __DIR__ . "/models/Goods.php";
require __DIR__ . '/vendor/autoload.php';

use Models\Apply;
use Models\CompanyPics;

$json = file_get_contents('php://input');
$json = json_decode($json, true);
if ($json == null) $json = [];
$concat = array_merge($json, $_GET);
$concat = array_merge($concat, $_FILES);
$concat = array_merge($concat, $_POST);
$data = json_decode(json_encode($concat));
//dd($data);
try
{
    $headers = getallheaders();
    $key = str_replace('Bearer ', '', $headers['Authorization']);
    $user = loginUser($key);
    if ($user == null) throw new Exception('尚未登入');
    if($user->is_admin == 1)
    {
        $user = \Models\Member::where('id', $data->user_id)->first();
        if($user == null) $user = \Models\Company::where('id', $data->user_id)->first();
        if($user == null) throw new Exception('請附加user_id');
    }

    if ($user->type == '企業')
    {
        $query = \Models\ApplyInvitation::with('job', 'seeker')->where('company_id', '=', $user->id)->orderBy('created_at', 'desc');
    }
    else
    {
        $query = \Models\ApplyInvitation::with('job', 'company')->where('seeker_id', '=', $user->id)->orderBy('created_at', 'desc');
    }
    $users = $query->paginate(20, ['*'], 'page', intval($data->page));

    header("Content-Type: application/json");
    echo json_encode(['issue' => 1, 'type' => $user->type, 'data' => $users, 'msg' => '']);
}
catch (Exception $e)
{
    echo json_encode(['issue' => 0, 'msg' => $e->getMessage()], JSON_UNESCAPED_UNICODE);
}


?>
