<?php
require_once __DIR__ . "/conn.php";
require __DIR__ . '/vendor/autoload.php';

use Illuminate\Database\Capsule\Manager as Capsule;
use Models\CompanyAD;
use Models\CompanySaveUser;

$json = file_get_contents('php://input');
$json = json_decode($json, true);
if ($json == null) $json = [];
$concat = array_merge($json, $_GET);
$data = json_decode(json_encode($concat));

try
{
    $headers = getallheaders();
    $key = str_replace('Bearer ', '', $headers['Authorization']);
    $user = loginUser($key);
    if ($user == null) throw new Exception('尚未登入');
    $model = CompanySaveUser::find($data->id);
    if($model == null) throw new Exception('找不到資料');
    if($user->id != $model->company_id) throw new Exception('權限不足');
    $model->delete();
    header("Content-Type: application/json");
    echo json_encode(['issue' => 1, 'msg' => '']);
}
catch (Exception $e)
{
    echo json_encode(['issue' => 0, 'msg' => $e->getMessage()], JSON_UNESCAPED_UNICODE);
}


?>