<?php

header("Access-Control-Allow-Origin: *");
header("Access-Control-Allow-Methods: GET, POST, PUT, DELETE, OPTIONS");
header("Access-Control-Allow-Headers: Content-Type, Authorization");

// 处理预检请求
if ($_SERVER['REQUEST_METHOD'] == 'OPTIONS') {
    // 如果是预检请求，返回200 OK
    header("HTTP/1.1 200 OK");
    exit();
}

require_once __DIR__ . '/vendor/autoload.php';
require_once __DIR__ . "/models/Apply.php";
require_once __DIR__ . "/models/Notice.php";
require_once __DIR__ . "/models/User.php";
require_once __DIR__ . "/models/Goods.php";
require_once __DIR__ . "/models/TopicImg.php";
require_once __DIR__ . "/models/TopicReply.php";
require_once __DIR__ . "/models/Topic.php";
require_once __DIR__ . "/models/Orders.php";
require_once __DIR__ . "/models/GoodsStar.php";
require_once __DIR__ . "/models/Job.php";
require_once __DIR__ . "/models/Member.php";
require_once __DIR__ . "/models/Goodstest.php";
require_once __DIR__ . "/models/HotJob.php";
require_once __DIR__ . "/models/HotCompany.php";
require_once __DIR__ . "/models/Selcategory.php";
require_once __DIR__ . "/models/CompanyJob.php";
require_once __DIR__ . "/models/Company.php";
require_once __DIR__ . "/models/Complace.php";
require_once __DIR__ . "/models/Composition.php";
require_once __DIR__ . "/models/HuntJob.php";
require_once __DIR__ . "/models/City.php";
require_once __DIR__ . "/models/Benefits.php";
require_once __DIR__ . "/models/Memberapply.php";
require_once __DIR__ . "/models/CompanyInvited.php";
require_once __DIR__ . "/models/Apply.php";
require_once __DIR__ . "/models/CompanyAD.php";
require_once __DIR__ . "/models/Recommend.php";
require_once __DIR__ . "/models/CompanyPics.php";
require_once __DIR__ . "/models/CompanySaveUser.php";
require_once __DIR__ . "/models/RecordInvited.php";
require_once __DIR__ . "/models/Resume.php";
require_once __DIR__ . "/models/ResumeEducations.php";
require_once __DIR__ . "/models/ResumeWorkExp.php";
require_once __DIR__ . "/models/ResumeWishJob.php";
require_once __DIR__ . "/models/ResumeStudentPeriod.php";
require_once __DIR__ . "/models/ResumeClubExp.php";
require_once __DIR__ . "/models/ResumeSchoolCompetition.php";
require_once __DIR__ . "/models/MemberCollectCompany.php";
require_once __DIR__ . "/models/MemberCollectJob.php";
require_once __DIR__ . "/models/ApplyInvitation.php";
require_once __DIR__ . "/models/RecordCompanyVisit.php";
require_once __DIR__ . "/models/RecordSeekerVisitJob.php";
require_once __DIR__ . "/models/ResumeWorkPics.php";
require_once __DIR__ . "/models/RecordSearchJob.php";
require_once __DIR__ . "/models/CompanyLetter.php";
require_once __DIR__ . "/models/PmRoom.php";
require_once __DIR__ . "/models/PmRoomRel.php";
require_once __DIR__ . "/models/IndustryCategory.php";

use Firebase\JWT\JWT;
use Firebase\JWT\Key;
use Illuminate\Database\Capsule\Manager as DB;

header('Access-Control-Allow-Origin:*');
header("Access-Control-Allow-Methods: GET, POST, PUT, DELETE, OPTIONS");
header("Access-Control-Allow-Headers: Content-Type, Authorization");
ini_set("display_errors", "On");

error_reporting(E_ALL & ~E_DEPRECATED & ~E_STRICT & ~E_WARNING & ~E_NOTICE);

ini_set('log_errors', 1);

ini_set('error_log', dirname(__FILE__) . '/error.log');

if ($_SERVER['REQUEST_METHOD'] === 'OPTIONS') {
    header("Access-Control-Allow-Origin: *");
    header("Access-Control-Allow-Methods: GET, POST, OPTIONS");
    header("HTTP/1.1 200 OK");
    exit;
}

use Carbon\Carbon;

Carbon::setLocale('Asia/Taipei');

// Create 4 variables to store these information
$server = "45.76.211.35";
$username = "manpower";
$password = "VI(t75gcgKuTX]ui";
$database = "manpower";
//// Create connection
//$conn = new mysqli($server, $username, $password, $database);
//// Check connection
//
//if ($conn->connect_error) {
//  die("Connection failed: " . $conn->connect_error);
//}

$options = [
    PDO::ATTR_PERSISTENT => false,
    PDO::ATTR_ERRMODE => PDO::ERRMODE_EXCEPTION,
    PDO::ATTR_EMULATE_PREPARES => false,
    PDO::ATTR_STRINGIFY_FETCHES => false,
    PDO::MYSQL_ATTR_INIT_COMMAND => 'SET NAMES utf8mb4',
];

$pdo = null;

//資料庫連線
try
{
    $pdo = new PDO('mysql:host=' . $server . ';port=3306;dbname=' . $database, $username, $password, $options);
    $pdo->exec('SET CHARACTER SET utf8mb4');
}
catch (PDOException $e)
{
    throw new PDOException($e->getMessage());
}

use Illuminate\Database\Capsule\Manager as Capsule;
use Models\Notice;

$capsule = new Capsule;

$capsule->addConnection([
    'driver' => 'mysql',
    'host' => $server,
    'database' => $database,
    'username' => $username,
    'password' => $password,
    'charset' => 'utf8',
    'collation' => 'utf8_unicode_ci',
    'prefix' => '',
]);

// Set the event dispatcher used by Eloquent models... (optional)
//use Illuminate\Events\Dispatcher;
use Illuminate\Container\Container;

//$capsule->setEventDispatcher(new Dispatcher(new Container));

// Make this Capsule instance available globally via static methods... (optional)
$capsule->setAsGlobal();

// Setup the Eloquent ORM... (optional; unless you've used setEventDispatcher())
$capsule->bootEloquent();

function loginUser($token)
{
    try
    {
        $key = "1-trebrOStUsTetR38UtHAkEhO0ridru95@9udOp";
        $algorithm = "HS256";
        $decoded = JWT::decode($token, new Key($key, 'HS256'));
//        dump($decoded);
        $user = \Models\Member::find($decoded->id);
//        dump($user);
        if ($user == null || $user->is_company == 1)
        {
            $user = \Models\Company::find($decoded->id);
            $user->type = '企業';
        }
        else
        {
            $user->type = '求職者';
        }
        return $user;
    }
    catch (Exception $e)
    {
        $uu = new stdClass;
        $uu->id = '';
        return $uu;
    }
}

function mm查詢既有聊天室($id1, $id2)
{
    $res = DB::select("
SELECT
	pm_room_rel.room_id,
	res1.room_id
FROM
	(
	SELECT
		pm_room_rel.room_id
	FROM
		pm_room_rel
		JOIN pm_room ON pm_room.id = pm_room_rel.room_id
	WHERE
		pm_room_rel.user_id = ?
	) res1
	LEFT JOIN pm_room_rel ON res1.room_id = pm_room_rel.room_id
WHERE
	pm_room_rel.user_id = ?", [$id1, $id2]);
    if (count($res) > 0) {
        return $res[0]->room_id;
    } else return null;
}

function db_insert($table, $keys, $data)
{
    global $pdo;
    $front = [];
    $after = [];
    foreach ($keys as $key)
    {
        array_push($front, $key);
        array_push($after, ':' . $key);
    }
    $front = implode(",", $front);
    $after = implode(",", $after);
    $sql = 'insert into ' . $table . ' (' . $front . ') values (' . $after . ')';
    $stmt = $pdo->prepare($sql);

    foreach ($keys as $key)
    {
        $stmt->bindValue(':' . $key, $data->{$key});
    }
    $stmt->execute();

//    $stmt->bindValue(':title', $data->birthday);
//    $stmt->bindValue(':cover', $data->avatar);
//    $stmt->bindValue(':category', $data->name);
//    $stmt->bindValue(':price', $data->price);
//    $stmt->bindValue(':price', $data->price);
}

function savePhoto($src,$dsc,$name)
{
        //生成一個唯一的檔案名稱
        $imageName = $name . ".jpg";
        //指定存儲圖片的路徑
        $imagePath = $dsc;
        //不存在就新增資料夾
        mkdir($imagePath, 0777, true);
        $imagePath .= $imageName;
        //儲存圖片到伺服器
        move_uploaded_file($src, $imagePath);
        return $imagePath;
}

function saveFile($src,$dsc,$name)
{
        //生成一個唯一的檔案名稱
        $imageName = $name;
        //指定存儲圖片的路徑
        $imagePath = $dsc;
        //不存在就新增資料夾
        mkdir($imagePath, 0777, true);
        $imagePath .= $imageName;
        //儲存圖片到伺服器
        move_uploaded_file($src, $imagePath);
        return $imagePath;
}

function generateRandomString($length = 10)
{
    $characters = '0123456789';
    $charactersLength = strlen($characters);
    $randomString = '';
    for ($i = 0; $i < $length; $i++)
    {
        $randomString .= $characters[random_int(0, $charactersLength - 1)];
    }
    return $randomString;
}

function addNotice($from_id, $to_id, $content)
{
    $model = new Notice;
    $model->id = generateRandomString(8);
    $model->from_id = $from_id;
    $model->user_id = $to_id;
    $model->content = $content;
    $model->save();
}

function dump($vv)
{
    echo '<pre>' . print_r($vv, true) . '</pre>';
    exit();
}

function updateNullasRealNull($tableName, $id)
{
    $pdo = DB::connection()->getPdo();
    $columns = DB::getSchemaBuilder()->getColumnListing($tableName);

    // 建立 SET 和 WHERE 子句
    $setClauses = [];
    $whereClauses = [];

    foreach($columns as $column) {
        if(in_array($column, ['id', 'created_at', 'updated_at'])) {
            continue;
        }
        $setClauses[] = "{$column} = CASE WHEN {$column} = 'null' THEN null ELSE {$column} END";
        $whereClauses[] = "{$column} = 'null'";
    }

    $sql = sprintf(
        "UPDATE ".$tableName." SET %s WHERE %s",
        implode(', ', $setClauses),
        implode(' OR ', $whereClauses)
    );

    $sql .= " AND id = '".$id."'";

    DB::statement($sql);
}

?>
