<?php
require_once __DIR__ . "/conn.php";
require_once __DIR__ . "/models/User.php";
require __DIR__ . '/vendor/autoload.php';

use Models\User;
use SendGrid\Mail\Mail;

$json = file_get_contents('php://input');
$data = json_decode($json);

try {


    $model = User::where('email', $data->email)->first();
    if ($model == null) {
        echo json_encode(['issue' => -1, 'data' => $model, 'msg' => '查無使用者']);
        exit();
    }
    
    $model->code = generateRandomString(6);
    $model->save();
    
    $email = new Mail();
    $email->setFrom("linkuliferd@gmail.com", "客服中心");
    $email->setSubject("你的驗證碼");
    $email->addTo($data->email, "Example User");
    $email->addContent(
        "text/html", "<h3><strong>{$model->code}</strong></h3>"
    );
    $sendgrid = new SendGrid("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");
    $response = $sendgrid->send($email);
 

    header("Content-Type: application/json");

    echo json_encode(['issue' => 1, 'data' => $model, 'msg' => '']);

} catch (Exception $e) {
    echo json_encode(['issue' => 0, 'msg' => $e->getMessage()]);
}


?>
