<?php
require_once __DIR__ . "/conn.php";
require_once __DIR__ . "/models/Goods.php";
require __DIR__ . '/vendor/autoload.php';

use Models\Company;
use Models\CompanyPics;
use Models\Member;

$json = file_get_contents('php://input');
$json = json_decode($json, true);
if ($json == null) $json = [];
$concat = array_merge($json, $_GET);
$concat = array_merge($concat, $_FILES);
$concat = array_merge($concat, $_POST);
$data = json_decode(json_encode($concat));
//dd($data);
//dump([$data->banner, $data->pics[1]]);
//dump($data->identity);
try
{
    //throw new Exception(gettype($data->avatar));

    $headers = getallheaders();
    //dump($headers);
    $key = str_replace('Bearer ', '', $headers['Authorization']);
    //dump($key);
    $user = loginUser($key);
    if ($user == null) throw new Exception('尚未登入');
    if($user->is_admin == 1)
    {
        $user = Company::where('id', $data->company_id)->first();
        if($user == null) throw new Exception('請指定company_id');
    }

    $model = \Models\Job::find($data->id);
    $crud = 'edit'; 
    if($model == null)
    {
        $model = new \Models\Job();
        $model->id = uniqid();
        $model->company_id = $user->id;
        $crud = 'add';
    }
    $keys = [
        'title','position','place','city','area','address','nature','job_people','work_shift','identity','content','salary_pay_method','salary_min','salary_max','businesstrip','workday','vacation_policy','shift_policy','employee_uniform',
        'management','features','driver_license','graduation','portfolio','major_limit','lang_require','proficient_tools','skills','certificate','other','c_name','c_email','c_for','c_phone','c_other'
    ];
    foreach ($keys as $k)
    { 
        if (property_exists($data, $k)) $model->{$k} = $data->{$k};
//        if (property_exists($data, 'lang_require'))
//        {
//            $model->lang_require = json_encode($data->lang_require);
//        }
    }
    $model->save();
    $model->crud = $crud;
    $model->lang_require = json_decode($model->lang_require);

    header("Content-Type: application/json");
    echo json_encode(['issue' => 1, 'data' => $model, 'msg' => '']);
}
catch (Exception $e)
{
    echo json_encode(['issue' => 0, 'msg' => $e->getMessage()]);
}


?>
