<?php
require_once __DIR__ . "/conn.php";
require __DIR__ . '/vendor/autoload.php';

use Illuminate\Database\Capsule\Manager as Capsule;
use Illuminate\Support\Carbon;
use Illuminate\Support\Str;
use Models\Member;

$json = file_get_contents('php://input');
$json = json_decode($json, true);
if ($json == null) $json = [];
$concat = array_merge($json, $_GET);
$data = json_decode(json_encode($concat));
//dump($data->jobType);
try
{
    if ($data->district == '地區') $data->district = '';

    $query = \Models\Member::with('resumes.wish', 'resumes.works', 'resumes.educations')
        ->orderBy('created_at', 'desc');
//        ->whereHas('resumes', function ($query) use ($data)
//        {
//            //$query->where('canuse', 'Y');
//
//            //有無自傳
//            if (Str::length($data->hasAutobiography) > 0)
//            {
//                if ($data->hasAutobiography == '有') $query->whereNotNull('autobiography');
//                if ($data->hasAutobiography == '無') $query->whereNull('autobiography');
//            }
//
//            //有無照片
//            if (Str::length(($data->hasAvatar)) > 0)
//            {
//                if ($data->hasAvatar == '有') $query->whereNotNull('avatar');
//                if ($data->hasAvatar == '無') $query->whereNull('avatar');
//            }
//
//            //最後更新日
//            if (Str::length(($data->lastUpdate)) > 0)
//            {
//                if ($data->lastUpdate == '三天內')
//                {
//                    $now = Carbon::now();
//                    $threeDaysAgo = $now->copy()->subDays(3)->startOfDay(); // 三天前的开始时间
//                    $query->whereBetween('updated_at', [$threeDaysAgo, $now]);
//                }
//                if ($data->lastUpdate == '一週內')
//                {
//                    $now = Carbon::now();
//                    $threeDaysAgo = $now->copy()->subDays(7)->startOfDay(); // 三天前的开始时间
//                    $query->whereBetween('updated_at', [$threeDaysAgo, $now]);
//                }
//                if ($data->lastUpdate == '兩週內')
//                {
//                    $now = Carbon::now();
//                    $threeDaysAgo = $now->copy()->subDays(14)->startOfDay(); // 三天前的开始时间
//                    $query->whereBetween('updated_at', [$threeDaysAgo, $now]);
//                }
//                if ($data->lastUpdate == '一個月內')
//                {
//                    $now = Carbon::now();
//                    $threeDaysAgo = $now->copy()->subDays(30)->startOfDay(); // 三天前的开始时间
//                    $query->whereBetween('updated_at', [$threeDaysAgo, $now]);
//                }
//                if ($data->lastUpdate == '兩個月內')
//                {
//                    $now = Carbon::now();
//                    $threeDaysAgo = $now->copy()->subDays(60)->startOfDay(); // 三天前的开始时间
//                    $query->whereBetween('updated_at', [$threeDaysAgo, $now]);
//                }
//                if ($data->lastUpdate == '三個月內')
//                {
//                    $now = Carbon::now();
//                    $threeDaysAgo = $now->copy()->subDays(90)->startOfDay(); // 三天前的开始时间
//                    $query->whereBetween('updated_at', [$threeDaysAgo, $now]);
//                }
//                if ($data->lastUpdate == '半年內')
//                {
//                    $now = Carbon::now();
//                    $threeDaysAgo = $now->copy()->subDays(180)->startOfDay(); // 三天前的开始时间
//                    $query->whereBetween('updated_at', [$threeDaysAgo, $now]);
//                }
//            }
//
//        });

//        ->whereHas('resumes.wish', function ($query) use ($data)
//        {
//            //期望工作地點
//            if (Str::length($data->district) > 0)
//            {
//                $array = explode(',', $data->district);
//                $query->where(function ($q) use ($array)
//                {
//                    foreach ($array as $index => $p)
//                    {
//                        $q->orWhere('work_at', 'like', '%' . $p . '%');
//                    }
//                });
//            }
//            //工作類型
//            if (count($data->jobType) > 0)
//            {
//                $array = $data->jobType;
//                $query->where(function ($q) use ($array)
//                {
//                    foreach ($array as $index => $p)
//                    {
//                        $q->orWhere('nature', $p);
//                    }
//                });
//            }
//
//        })->whereHas('resumes.educations', function ($query) use ($data)
//        {
//            //學歷
//            if (Str::length($data->education) > 0)
//            {
//                $array = explode(',', $data->education);
//                $query->where(function ($q) use ($array)
//                {
//                    foreach ($array as $index => $p)
//                    {
//                        $q->orWhere('degree', 'like', '%' . $p . '%');
//                    }
//                });
//            }
//
//        });

    //性別
    if (Str::length($data->sex) > 0)
    {
        $query->where('sex', $data->sex);
    }
    //特殊身分
    if (Str::length($data->identity) > 0)
    {
        $query->where('identity', 'like', '%'.$data->identity.'%');
    }
    //年齡
    if ($data->age_lower != null && $data->age_upper != null)
    {
        $today = Carbon::now();
        $birthDateStart = $today->copy()->subYears($data->age_upper)->startOfDay();
        $birthDateEnd = $today->copy()->subYears($data->age_lower)->endOfDay();
        $query->whereBetween('birth', [$birthDateStart, $birthDateEnd]);
    }

    //關鍵字
    if ($data->like != '')
    {
        $query->where(function ($q) use ($data)
        {
            $q->orWhere('name', 'like', '%' . $data->like . '%')
                ->orWhere('email', 'like', '%' . $data->like . '%')
                ->orWhere('intro', 'like', '%' . $data->like . '%');

        });
    }


    //工作類型
//    if (count($data->jobType) > 0)
//    {
//        $query->whereHas('resumes.wish_use', function ($query) use ($data)
//        {
//            $array = $data->jobType;
//            $query->where('nature', $array[0]);
//            if (count($array) > 1)
//            {
//                foreach ($array as $item)
//                {
//                    $query->orWhere('nature', $item);
//                }
//            }
//        }, '>=', 10);
//    }
    //總工作經驗
    if (($data->totalJobExp) != '')
    {
//        $query->whereHas('resumes.works', function ($query) use ($data)
//        {
//            if ($data->totalJobExp == '無經驗')
//            {
//                $query->doesntHave('resumes.works');
//            }
//            else
//            {
//                $query->whereRaw('(YEAR(end) - YEAR(begin)) >= ?', [1]);
//            }
//        });
    }


    $users = $query->paginate(8, ['*'], 'page', intval($data->page));
    header("Content-Type: application/json");
    echo json_encode(['issue' => 1, 'data' => $users, 'msg' => '']);
}
catch (Exception $e)
{
    echo json_encode(['issue' => 0, 'msg' => $e->getMessage()]);
}
?>