<?php
require_once __DIR__ . "/conn.php";
require_once __DIR__ . "/models/Orders.php";
require_once __DIR__ . "/models/Goods.php";
require_once __DIR__ . "/models/Pm.php";
require_once __DIR__ . "/models/PmRoom.php";
require_once __DIR__ . "/models/PmRoomRel.php";
require_once __DIR__ . "/models/User.php";
require __DIR__ . '/vendor/autoload.php';

use Models\Goods;
use Models\Orders;

$json = file_get_contents('php://input');
$data = json_decode($json);
//echo json_encode(['issue' => 1, 'msg' => json_encode($data)]);
//exit();
try {
    //Orders裡面的user_id永遠是買家
//    $model = Orders::where('user_id', $data->user_id)->where('goods_id', $data->id)->first();
    $model = Orders::find($data->orders_id);
    $model->status = $data->orders_status;
    $model->save();

    if (in_array($data->orders_status, ['買家取消'])) {
        $goods = Goods::find($data->id);
        $goods->buy_id = null;
        $goods->save();

        $from = \Models\User::find($data->user_id);
        addNotice($goods->user_id, $goods->user_id, "你販售的商品[{$goods->title}]被買家取消交易，已重新上架!");
        addNotice($model->user_id, $model->user_id, "你購買的商品[{$goods->title}]，已取消交易...");
    }
    if (in_array($data->orders_status, ['賣家取消'])) {
        $goods = Goods::find($data->id);
        $goods->buy_id = null;
        $goods->save();
        
        addNotice($goods->user_id, $goods->user_id, "你販售的商品[{$goods->title}]已取消交易，已重新上架!");
        addNotice($model->user_id, $model->user_id, "你購買的商品[{$goods->title}]，賣家已取消交易...");
    }
    if (in_array($data->orders_status, ['成交'])) {
        $goods = Goods::find($data->id);
        $goods->status = '已售出';
        $goods->save();

        addNotice($goods->user_id, $goods->user_id, "你販售的商品[{$goods->title}]已成交!");
        addNotice($model->user_id, $model->user_id, "你購買的商品[{$goods->title}]已成交!");
    }


    header("Content-Type: application/json");
    echo json_encode(['issue' => 1, 'msg' => '']);
} catch (Exception $e) {
    echo json_encode(['issue' => 0, 'msg' => $e->getMessage()]);
}


?>
