<?php
/**
 * 企業造訪求職者
 */
require_once __DIR__ . "/conn.php";
require_once __DIR__ . "/models/Goods.php";
require __DIR__ . '/vendor/autoload.php';

use Models\Apply;
use Models\CompanyPics;

$json = file_get_contents('php://input');
$json = json_decode($json, true);
if ($json == null) $json = [];
$concat = array_merge($json, $_GET);
$concat = array_merge($concat, $_FILES);
$concat = array_merge($concat, $_POST);
$data = json_decode(json_encode($concat));
//dd($data);
try
{
    $headers = getallheaders();
    $key = str_replace('Bearer ', '', $headers['Authorization']);
    $user = loginUser($key);
    if ($user == null) throw new Exception('尚未登入');

    if ($user->type == '企業')
    {
        $query = \Models\RecordCompanyVisit::with('seeker')->where('company_id', '=', $user->id)->orderBy('created_at', 'desc');
    }
    else
    {
        $query = \Models\RecordCompanyVisit::with('company')->where('record_company_visit.seeker_id', '=', $user->id)->leftJoin('member_collect_company', function ($join) use ($data, $user)
        {
            $join->on('record_company_visit.company_id', '=', 'member_collect_company.company_id')->where('member_collect_company.user_id', $user->id);
        })->select('record_company_visit.*', 'member_collect_company.id as isCollect')->orderBy('created_at', 'desc');
    }
    $users = $query->paginate(20, ['*'], 'page', intval($data->page));

    header("Content-Type: application/json");
    echo json_encode(['issue' => 1, 'type' => $user->type, 'data' => $users, 'msg' => '']);
}
catch (Exception $e)
{
    echo json_encode(['issue' => 0, 'msg' => $e->getMessage()], JSON_UNESCAPED_UNICODE);
}


?>
