<?php
require_once __DIR__ . "/conn.php";
require_once __DIR__ . "/models/Goods.php";
require __DIR__ . '/vendor/autoload.php';

use Models\Resume;
use Models\CompanyPics;

$json = file_get_contents('php://input');
$json = json_decode($json, true);
if ($json == null) $json = [];
$concat = array_merge($json, $_GET);
$concat = array_merge($concat, $_FILES);
$concat = array_merge($concat, $_POST);
$data = json_decode(json_encode($concat));
//dd($data);
//dump([$data->banner, $data->pics[1]]);
//dump($data->pics);
try
{
    //throw new Exception(gettype($data->avatar));

    $headers = getallheaders();
    //dump($headers);
    $key = str_replace('Bearer ', '', $headers['Authorization']);
    //dump($key);
    $user = loginUser($key);
    if ($user == null) throw new Exception('尚未登入');
    if($user->is_admin == 1)
    {
        $user = \Models\Member::where('id', $data->user_id)->first();
        if($user == null) throw new Exception('請指定user_id');
    }
    else if ($user->type != '求職者') throw new Exception('無權限');
    //dump($user);

    $resume = Resume::find($data->id);
    if ($resume == null)
    {
        $resume = new Resume();
        $resume->id = uniqid();
        $resume->user_id = $user->id;
        $resume->save();
    }

    //更新作品附件照片
    if (gettype($data->pics) == 'object')
    {
        foreach ($data->pics->tmp_name as $index => $pic)
        {
            //dump($index);
            $model = new \Models\ResumeWorkPics;
            $model->id = uniqid();
            $model->resume_id = $resume->id;
            $imageFileType = strtolower(pathinfo($data->pics->name[$index],PATHINFO_EXTENSION));
            //dump($pic);
            $model->path = saveFile($data->pics->tmp_name[$index], "images/resume/pics/", uniqid() . ".".$imageFileType);
            $model->save();
        }
    }

    $keys = [
        'name', 'licenses', 'cars', 'lang_ability', 'lang_other', 'certification', 'computer_skill', 'other_expertise', 'autobiography'
    ];
    foreach ($keys as $k)
    {
        if (property_exists($data, $k)) $resume->{$k} = $data->{$k};
    }

    if (property_exists($data, 'educations'))
    {
        if (is_string($data->educations)) $data->educations = json_decode(($data->educations));
        foreach ($data->educations as $edu)
        {
            //dump($edu);
            $model = \Models\ResumeEducations::find($edu->id);
            if ($model == null)
            {
                $model = new \Models\ResumeEducations();
                $model->id = uniqid();
                $model->resume_id = $resume->id;
            }
            $model->status = $edu->status;
            $model->name = $edu->name;
            $model->begin = $edu->begin;
            $model->end = $edu->end;
            $model->major_category = $edu->major_category;
            $model->major = $edu->major;
            $model->degree = $edu->degree;
            $model->save();
        }
    }
    if (property_exists($data, 'student_period'))
    {
        if (is_string($data->student_period)) $data->student_period = json_decode(($data->student_period));
        foreach ($data->student_period as $edu)
        {
            //dump($edu);
            $model = \Models\ResumeStudentPeriod::find($edu->id);
            if ($model == null)
            {
                $model = new \Models\ResumeStudentPeriod();
                $model->id = uniqid();
                $model->resume_id = $resume->id;
            }
            $model->name = $edu->name;
            $model->begin = $edu->begin;
            $model->end = $edu->end;
            $model->content = $edu->content;
            $model->school = $edu->school;
            $model->save();
        }
    }
    if (property_exists($data, 'club_exp'))
    {
        if (is_string($data->club_exp)) $data->club_exp = json_decode(($data->club_exp));
        foreach ($data->club_exp as $edu)
        {
            //dump($edu);
            $model = \Models\ResumeClubExp::find($edu->id);
            if ($model == null)
            {
                $model = new \Models\ResumeClubExp();
                $model->id = uniqid();
                $model->resume_id = $resume->id;
            }
            $model->name = $edu->name;
            $model->begin = $edu->begin;
            $model->end = $edu->end;
            $model->content = $edu->content;
            $model->school = $edu->school;
            $model->officer = $edu->officer;
            $model->save();
        }
    }
    if (property_exists($data, 'school_competition'))
    {
        if (is_string($data->school_competition)) $data->school_competition = json_decode(($data->school_competition));
        foreach ($data->school_competition as $edu)
        {
            //dump($edu);
            $model = \Models\ResumeSchoolCompetition::find($edu->id);
            if ($model == null)
            {
                $model = new \Models\ResumeSchoolCompetition();
                $model->id = uniqid();
                $model->resume_id = $resume->id;
            }
            $model->name = $edu->name;
            $model->award_date = $edu->award_date;
            $model->rank = $edu->rank;
            $model->content = $edu->content;
            $model->school = $edu->school;
            $model->save();
        }
    }
    if (property_exists($data, 'works'))
    {
        //if(!is_array($data->works))
        if (is_string($data->works)) $data->works = json_decode($data->works);
        foreach ($data->works as $edu)
        {
            //dump($edu);
            $model = \Models\ResumeWorkExp::find($edu->id);
            if ($model == null)
            {
                $model = new \Models\ResumeWorkExp();
                $model->id = uniqid();
                $model->resume_id = $resume->id;
            }
            $model->name = $edu->name;
            $model->category = $edu->category;
            $model->begin = $edu->begin;
            $model->end = $edu->end;
            $model->job_title = $edu->job_title;
            $model->nature = $edu->nature;
            $model->manager = $edu->manager;
            $model->paid = $edu->paid;
            $model->isStill = $edu->isStill;
            $model->job_category = $edu->job_category;
            $model->save();
        }
    }
    if (property_exists($data, 'wish'))
    {
        if (is_string($data->wish)) $data->wish = json_decode(($data->wish));
        foreach ($data->wish as $edu)
        {
            //dump($edu);
            $model = \Models\ResumeWishJob::find($edu->id);
            if ($model == null)
            {
                $model = new \Models\ResumeWishJob();
                $model->id = uniqid();
                $model->resume_id = $resume->id;
            }
            $model->category = $edu->category;
            $model->begin = $edu->begin;
            $model->end = $edu->end;
            $model->job_category = $edu->job_category;
            $model->job_title = $edu->job_title;
            $model->nature = $edu->nature;
            $model->salary_min = $edu->salary_min;
            $model->salary_max = $edu->salary_max;
            $model->work_shift = $edu->work_shift;
            $model->workday = $edu->workday;
            $model->work_at = $edu->work_at;
            $model->salary_pay_method = $edu->salary_pay_method;
            $model->save();
        }
    }
    $resume->save();

    $resume = Resume::where('id', $resume->id)->with('student_period', 'wish', 'educations', 'works', 'club_exp', 'school_competition')->first();

    header("Content-Type: application/json");
    echo json_encode(['issue' => 1, 'data' => $resume, 'msg' => '']);
}
catch (Exception $e)
{
    echo json_encode(['issue' => 0, 'msg' => $e->getMessage()]);
}


?>
