<?php
header("Content-Type: application/json");
require_once __DIR__ . "/conn.php";
require_once __DIR__ . "/models/Goods.php";
require __DIR__ . '/vendor/autoload.php';

use Firebase\JWT\JWT;
use GuzzleHttp\Client;
use Models\Member;

$json = file_get_contents('php://input');
$json = json_decode($json, true);
if ($json == null) $json = [];
$concat = array_merge($json, $_GET);
$concat = array_merge($concat, $_FILES);
$concat = array_merge($concat, $_POST);
$data = json_decode(json_encode($concat));
//dd($data);

try
{
    if(Member::where('email', $data->email)->first() != null) throw new Exception('此Email已被註冊');
    $model = new Member;
    $model->id = uniqid();
    $keys = ['name', 'sex', 'birth', 'email', 'phone', 'tel', 'contactstart', 'contactend', 'vaccine', 'password','city','area','address','identity','intro'];
    foreach ($keys as $k)
    {
        $model->{$k} = $data->{$k};
    }
    if ($data->avatar != null)
    {
        $model->avatar = savePhoto($data->avatar->tmp_name, 'images/seeker/cover/', $model->id);
    }
    $model->save();

    $key = "1-trebrOStUsTetR38UtHAkEhO0ridru95@9udOp";
    $algorithm = "HS256";
    $userData = ['email' => $model->email, 'id' => $model->id];
    $token = JWT::encode($userData, $key, $algorithm);

    $client = new Client();
    $requestDate = [
        "name" => "預設",
        "cars" => "",
        "licenses" => "",
        "lang_ability" => "",
        "lang_other" => "",
        "computer_skill" => "",
        "certification" => "",
        "other_expertise" => "",
        "autobiography" => "",
        "educations" => [],
        "student_period" => [],
        "club_exp" => [],
        "school_competition" => [],
        "works" => [],
        "wish" => []
    ];
    $response = $client->request('POST', 'https://case.unood.me/manpower/resumeEdit.php', [
        'headers' => [
            'Authorization' => 'Bearer ' . $token,
            'Accept'        => 'application/json',
        ],
        'json' => $requestDate
    ]);

    $res = $response->getBody()->getContents();
    $res = json_decode($res, true);
    echo json_encode(['issue' => 1, 'data' => $model, 'msg' => '', 'token' => $token, 'resumeReturn'=>$res]);
}
catch (Exception $e)
{
    echo json_encode(['issue' => 0, 'msg' => $e->getMessage()]);
}
?>
